#*****************************************************************************************************************************************************
#*  
#*  (C) 2011     Marek Walesiak     Uniwersytet Ekonomiczny we Wrocawiu
#*
#*  Skrypt do ksiki:
#*  Walesiak M., Uoglniona miara odlegoci GDM w statystycznej analizie wielowymiarowej z wykorzystaniem programu R, Wydawnictwo UE, Wrocaw 2011.
#*  
#*  Kod poniszy moe by modyfikowany, kopiowany i rozprowadzany na warunkach licencji GPL 2 (http://gnu.org.pl/text/licencja-gnu.html), 
#*  a w szczeglnoci pod warunkiem umieszczenia w zmodyfikowanym pliku widocznej informacji o dokonanych zmianach, wraz z dat ich dokonania. 
#*  
#*****************************************************************************************************************************************************

library(kernlab)
library(mlbench)
library(clusterSim)
library(panel)
data(data_patternGDM2)
x<-data_patternGDM2
options(OutDec=",")
res<-speccl(x,nc=4,distance="GDM2",sigma="automatic",mod.sample=0.75,R=10,iterations=3)
print("Liczba obiektw w klasach",quote=F)
print(res$size)
print("Optymalna sigma",quote=F)
print(res$sigma)
clas1<-res$cluster
xx<-1:nrow(x)
dim(clas1)<-c(length(clas1),1)
cl_wyn1<-as.data.frame(clas1)
row.names(cl_wyn1)<-xx
colnames(cl_wyn1)<-"klasa"
print("Prezentacja klasyfikacji wynikowej - uporzdkowana",quote=F)
ord<-order(cl_wyn1[,"klasa"],decreasing=F)
cl_wyn2<-as.data.frame(cl_wyn1[ord,])
row.names(cl_wyn2)<-xx[ord]
colnames(cl_wyn2)<-"klasa"
print(cl_wyn2)
desc <-cluster.Description(x,clas1,"population")
print("Dominanty",quote=F)
print(desc[,,5])
